#!/bin/sh
export LC_ALL=C

limit=
node_id=$1
(
echo '<?xml version="1.0" encoding="iso8859-1"?>'
echo '<xml xmlns:xi="http://www.w3.org/2001/XInclude">'
echo '<xi:include href="titles.xml"><xi:fallback/></xi:include>'
mysql cowiki -s -e \
"select concat('<node id=\"', node_id, '\" parent_id=\"', parent_id, '\" name=\"', replace(replace(name, '&', '&amp;'), '\"', '&quot;'), '\">', content, '</node>') from cowiki_node where is_dir!='Y' ${node_id:+and node_id=$node_id}${limit:+ limit $limit}" | \
perl -pe 's,\\n,\n,g'
echo '</xml>'
) > ${node_id:-cowiki}.xml

(
echo '<?xml version="1.0" encoding="iso8859-1"?>'
echo '<titles>'
mysql cowiki -s -e \
"select concat('<node id=\"', node_id, '\" title=\"', replace(replace(name, '&', '&amp;'), '\"', '&quot;'), '\"/>') from cowiki_node" | \
perl -pe 's,\\n,\n,g'
echo '</titles>'
) > titles.xml

# directories with wiki page as index
mysql cowiki --xml -e \
"select a.node_id id,a.name title,b.node_id xid,b.name xtitle from cowiki_node a, cowiki_node b where b.is_index='Y' and b.parent_id=a.node_id" \
> dirs.xml

# directories who have no index
(
echo '<?xml version="1.0" encoding="iso8859-1"?>'
echo '<xml xmlns:xi="http://www.w3.org/2001/XInclude">'
echo '<xi:include href="titles.xml"><xi:fallback/></xi:include>'
nodes=$(mysql cowiki -s -e "select parent_id id from cowiki_node node1 where parent_id>0 and not exists (select * from cowiki_node node2 where node2.parent_id=node1.parent_id and node2.is_index='Y') group by parent_id")
for node in $nodes; do
	echo "<node id=\"$node\">"
	mysql cowiki -s -e \
	"select concat('<link id=\"', node_id, '\"/>') from cowiki_node where parent_id=$node order by sort_order"
	echo "</node>"
done
echo '</xml>'
) > index.xml
